"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

var _createClass = (function () { function defineProperties(target, props) { for (var key in props) { var prop = props[key]; prop.configurable = true; if (prop.value) prop.writable = true; } Object.defineProperties(target, props); } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _inherits = function (subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } };

var EventEmitter = require("eventemitter3").EventEmitter;

var assign = _interopRequire(require("object-assign"));

var Store = (function (_EventEmitter) {
    function Store() {
        _classCallCheck(this, Store);

        if (_EventEmitter != null) {
            _EventEmitter.apply(this, arguments);
        }
    }

    _inherits(Store, _EventEmitter);

    _createClass(Store, {
        handleAction: {

            /**
             * Register an action handler
             * @param  {String}   id      Id of the action (e.g. 'todos.create')
             * @param  {Function} handler Action handler
             * @return {void}
             */

            value: function handleAction(id, handler) {
                if (!this._handlers) this._handlers = {};

                if (typeof handler !== "function") {
                    throw new Error("Handler for action " + id + " is not a function. " + ("Attempted to register action handler in " + this.constructor.name + "."));
                }
                if (!this._actionIdExists(id)) {
                    throw new Error("Action " + id + " does not exist. " + ("Attempted to register action handler in " + this.constructor.name + "."));
                }
                if (this._handlers[id]) {
                    throw new Error("Handler for action " + id + " is already registered. " + ("Attempted to register action handler in " + this.constructor.name + "."));
                }

                this._handlers[id] = handler.bind(this);
            }
        },
        stopHandleAction: {

            /**
             * Unregister an action handler
             * @param  {String} id  Id of the action (e.g. 'todos.create')
             * @return {void}
             */

            value: function stopHandleAction(id) {
                if (!id || !this._handlers || !this._handlers[id]) {
                    return;
                }this._handlers[id] = undefined;
            }
        },
        setState: {

            /**
             * Set state
             * @param {Object} state State object
             */

            value: function setState(state) {
                var options = arguments[1] === undefined ? {} : arguments[1];

                if (!state) {
                    return;
                }if (!this.state) this.state = {};
                this.state = assign({}, this.state, state);

                if (options.silent !== true) {
                    this.emit("change", this.state);
                }
            }
        },
        getState: {

            /**
             * Returns the state
             * @return {Object} The state object
             */

            value: function getState() {
                return this.state || {};
            }
        },
        _actionIdExists: {

            /**
             * Check if action id exists
             * @return {Boolean}
             */

            value: function _actionIdExists(id) {
                // This method will be overriden by the dispatcher.
                // When testing stores without the dispatcher, always return true
                return true;
            }
        }
    });

    return Store;
})(EventEmitter);

module.exports = Store;